<?php

abstract class Level
{
  const UNKNOWN = -1;
  const RENTER = 0;
  const OWNER = 1;

  public static function toString($type): string
  {
    switch ($type) {
      case self::RENTER:
        return "renter";
      case self::OWNER:
        return "owner";
      default:
        return "unknown";
    }
  }
}