<?php
  include_once '../../config/header_default_server.php';
  include_once '../../config/database.php';

  include_once '../../models/news.php';

  // Instantiate DB & connect
  $database = new Database();
  $db = $database->connect();

  // Instantiate news object
  $news = new News($db);


  /**************************************************/

  $arr = array();

  if( isset($data) ) {
    foreach ($data as $key => $value) {
      if( $key != "token" )
        array_push($arr, $value);
    }
  }
  else {
    error_log( "ERROR: Could not delete mulitple messages...", 0);
    return;
  }

  // Delete news
  if($news->delete_multiple_news( $arr )) {
    error_log( "INFO: Multiple News deleted...", 0);
    echo json_encode(
      array('message' => 'News Deleted')
    );
  } else {
    error_log( "WARNING: Multiple News NOT deleted...", 0);
    echo json_encode(
      array('message' => 'News Not Deleted')
    );
  }