<?php 
  include_once '../../config/header_default_server.php';
  include_once '../../config/database.php';
  include_once '../../models/helper.php';

  include_once '../../models/object.php';

  // Instantiate DB & connect
  $database = new Database();
  $db = $database->connect();

  // Instantiate object
  $object = new Obj($db);


  /**************************************************/

  // Get raw posted data and check if data exists
  $data = json_decode(file_get_contents("php://input"));
  if( !isset( $data) ) {
    error_log( "WARNING: PollActive body data were not found... ", 0);
    header("HTTP/1.1 404 Not Found");
    exit();
  }

  /**************************************************/


  if( isset($data->hid) )
    $object->hid = urldecode( $data->hid );

  // Object query
  $result = $object->get_object_by_hid();

  if( is_array($result) && count($result) > 0 ) {
    echo json_encode( $result );
  } else {
    // No objects
    echo json_encode( array() );
  }