<?php 
  //include_once '../../config/header_default_server.php';
  include_once '../../config/database.php';

  include_once '../../models/poll.php';

  // Instantiate DB & connect
  $database = new Database();
  $db = $database->connect();

  // Instantiate poll object
  $poll = new Poll($db);


  /**************************************************/

  // Get raw posted data and check if data exists
  $data = json_decode(file_get_contents("php://input"));
  if( !isset( $data) ) {
    error_log( "WARNING: PollActive body data were not found... ", 0);
    header("HTTP/1.1 404 Not Found");
    exit();
  }

  /**************************************************/


  if( isset($data->phash) )
    $poll->phash = urldecode( $data->phash );

  $decision = 0;
  if( isset($data->decision) )
    $decision = (int)$data->decision;

  $result = $poll->activate_decision_by_poll( $decision );

  if( $result == false ) {
    error_log( "WARNING: Was not able to activate decision... phash: " . $poll->phash, 0);
  }
  
  echo $decision;
