<?php 
  include_once '../../config/header_default_server.php';
  include_once '../../config/database.php';

  include_once '../../models/poll.php';

  // Instantiate DB & connect
  $database = new Database();
  $db = $database->connect();

  // Instantiate poll object
  $poll = new Poll($db);


  /**************************************************/

  // Get raw posted data and check if data exists
  $data = json_decode(file_get_contents("php://input"));
  if( !isset( $data) ) {
    error_log( "WARNING: PollActive body data were not found... ", 0);
    header("HTTP/1.1 404 Not Found");
    exit();
  }

  /**************************************************/


  if( isset($data->phash) )
    $poll->phash = urldecode( $data->phash );


  //get polls
  $data = $poll->get_all_answers_by_poll();

  if( $data != null ) {

    //poll array
    $poll_arr = array();

    while( $row = $data->fetch(PDO::FETCH_ASSOC) ) {
      extract( $row );

      //create item/row
      $poll_item = array(
        'hash' => $hash,
        'first_name' => html_entity_decode($first_name),
        'last_name' => html_entity_decode($last_name),
        'company' => html_entity_decode($company),
        'answer_1' => html_entity_decode($answer_1),
        'answer_2' => html_entity_decode($answer_2),
        'answer_3' => html_entity_decode($answer_3),
        'answer_4' => html_entity_decode($answer_4),
        'answer_5' => html_entity_decode($answer_5),
        'answer_6' => html_entity_decode($answer_6),
        'answer_7' => html_entity_decode($answer_7),
        'answer_8' => html_entity_decode($answer_8),
        'answer_9' => html_entity_decode($answer_9),
        'answer_10' => html_entity_decode($answer_10),
        'answer_11' => html_entity_decode($answer_11),
        'answer_12' => html_entity_decode($answer_12),
        'answer_13' => html_entity_decode($answer_13),
        'answer_14' => html_entity_decode($answer_14),
        'answer_15' => html_entity_decode($answer_15),
        'answer_16' => html_entity_decode($answer_16),
        'answer_17' => html_entity_decode($answer_17),
        'answer_18' => html_entity_decode($answer_18),
        'answer_19' => html_entity_decode($answer_19),
        'answer_20' => html_entity_decode($answer_20),
        'answer_21' => html_entity_decode($answer_21),
        'answer_22' => html_entity_decode($answer_22),
        'answer_23' => html_entity_decode($answer_23),
        'answer_24' => html_entity_decode($answer_24),
        'answer_25' => html_entity_decode($answer_25),
        'answer_26' => html_entity_decode($answer_26),
        'answer_27' => html_entity_decode($answer_27),
        'answer_28' => html_entity_decode($answer_28),
        'answer_29' => html_entity_decode($answer_29),
        'answer_30' => html_entity_decode($answer_30)
      );

      // Push data set to array
      array_push( $poll_arr, $poll_item );
    }

    //return value
    echo json_encode( $poll_arr );
    return;
  }

  echo json_encode( array("null" => "null") );