<?php
$config = require_once '../../config/config.php';

//assign data to news class
$pid = $_POST["pid"];
$last_name = $_POST["last_name"];
$first_name = $_POST["first_name"];
$company = $_POST["company"];
$hash = $_POST["hash"];
$email = $_POST["mail"];

$to = $email;
//$from = $EMAIL_MAIN_ADDR;
$from = $config['mail']['main'];

$playstore = "https://play.google.com/store/apps/details?id=de.friegel_design.kappel_hausverwaltung.app";
$appstore = "https://apps.apple.com/de/app/kappel-hausverwaltung/id1448134618";

$subject = 'Kappel Hausverwaltung, App';

$message = "<html><body>";

if ($company != "" || $first_name == "")
  $message .= "Sehr geehrte Damen und Herren,<br>";
else
  $message .= "Hallo <strong>$first_name $last_name</strong>,<br>";

$message .= "hiermit sind Sie für die App 'Kappel Hausverwaltung' freigeschaltet.<br><br>";
$message .= "Um die App nun nutzen zu können, müssen Sie folgende drei Schritte ausführen:<br><br>";
$message .= "1. Laden Sie die passende App für Ihr Gerät: <a href='" . $appstore . "'>App Store (iOS)</a> oder <a href='" . $playstore . "'>Play Store (Android)</a>.<br>";
$message .= "2. Starten Sie die App das erste Mal.<br>";
$message .= "3. Kommen Sie nun zurück zu dieser E-Mail und klicken Sie auf den nachfolgenden QR-Code (falls Sie diese Mail mit dem Smartphone geöffnet haben) ODER Sie klicken in der App auf 'mit Wohnung verbinden' und scannen den QR-Code ab:<br>";

// QR-Code + Base64 coding
$qrUrl = "https://quickchart.io/qr?size=300&text=" . $hash;
$qrCodeImage = file_get_contents($qrUrl);
$base64Image = base64_encode($qrCodeImage);

$message .= "<a href='https://hausverwaltung-kappel.de/app/redirect.php?hash=" . $hash . "'><img src='data:image/png;base64, $base64Image' /></a><br>";

$message .= "Fertig. Nun sollten Sie eingewählt sein und bereits Daten von Ihrer Hausverwaltung empfangen haben!<br><br>";
$message .= "Viel Spaß bei der Benutzung der App!<br>";
$message .= "Ihre Hausverwaltung Kappel.<br><br><br>";
$message .= "<i>Bei Problemen:<br>";
$message .= "Bitte stellen Sie sicher, dass Sie die obigen 3 Schritte durchgeführt haben und dass Ihre Internetverbindung aktiv ist.<br>";
$message .= "Sollte das Klicken auf QR-Code trotz mehreren Versuchen nicht funktionieren, bitte scannen Sie sich via App und QR-Code ein.<br>";
$message .= "Generell Feedback oder falls das Problem nicht behoben werden konnte, bitte senden Sie eine E-Mail an " . $config['mail']['service'] . "</i>";
$message .= "</body></html>";

//$headers = "From: " . strip_tags($_POST['req-email']) . "\r\n";
$headers = "From: $from\r\nSender-IP: " . $_SERVER['REMOTE_ADDR'] . "\r\n";
//$headers .= "Reply-To: ". strip_tags($_POST['req-email']) . "\r\n";
//test purpose
$headers .= "Bcc: " . $config['mail']['service'] . "\r\n";
$headers .= "MIME-Version: 1.0\r\n";
$headers .= "Content-Type: text/html; charset=utf-8\r\n";

$mail = @mail($to, $subject, $message, $headers);

if ($mail) {
  echo "QR Code wurde erfolgreich versendet!";
  /*error_log("INFO: QR-Mail is sent successful. #" . $pid . " - " . $last_name . " - " . $first_name . " - " . $company . " - " . $hash . " - " . $email, 0);*/

  ///////////////////////////////////////// QR MAIL SENT
  include_once '../../config/database.php';
  include_once '../../models/client.php';
  include_once '../../models/helper.php';

  // Instantiate DB & connect
  $database = new Database();
  $db = $database->connect();

  // Instantiate blog client object
  $client = new Client($db);

  // Get hash
  $client->hash = $hash;

  // Get client
  $client->increment_qr_mail_sent();
  ///////////////////////////////////////// QR MAIL SENT

} else {
  echo "Fehler beim Versenden des QR Codes!";
  error_log("ERROR: QR-Mail could not be sent. #" . $pid . " - " . $last_name . " - " . $first_name . " - " . $company . " - " . $hash . " - " . $email, 0);
}