<?php 
  // Headers
  header('Access-Control-Allow-Origin: *');
  header('Content-Type: application/json');
  header('Access-Control-Allow-Methods: POST');
  header('Access-Control-Allow-Headers: Access-Control-Allow-Headers,Content-Type,Access-Control-Allow-Methods, Authorization, X-Requested-With');

  include_once '../config/database.php';
  include_once '../models/ologging.php';

  // Instantiate DB & connect
  $database = new Database();
  $db = $database->connect();

  // Instantiate log object
  $olog = new OLog($db);

  // Get raw posted data
  $data = json_decode(file_get_contents("php://input"));

  //assign data to news class
  if( isset($data->tag) )
    $olog->tag = urldecode( $data->tag );

  if( isset($data->message) )
    $olog->message = urldecode( $data->message );

  if( isset($data->hash) )
    $olog->deviceId = urldecode( $data->hash );

  // Create olog
  if( $olog->tag != "" && $olog->create_log() ) {
    header("HTTP/1.1 200 OK");
    /*echo json_encode(
      array('message' => 'News Created')
    );*/
  } 
  else {
    header("HTTP/1.1 404 Not Found");
    /*echo json_encode(
      array('message' => 'News NOT created')
    );*/
  }