/*this.imagePreview = function(){ 
  $("a").hover(function(e){
  });  
};*/

$(document).ready(function() {
//jQuery(document).ready(function($) {

  fetch_data();  
  //imagePreview();

  $(document).on('click', '.btn_delete_client', function(){
      var pid=$(this).data("pid"); 
      var active=$(this).data("active");
      var activeStr = "aktiv";

      if( active ) activeStr = "inaktiv";

      if(confirm("Bist du Dir sicher, dass du diesen Kunden-Status umschalten möchtest (ID: "+pid+", neuer Status: "+activeStr+")?"))  
      {  
          $.ajax({
              type: "POST",
              url:"../api/server/active.php",  
              data:{ pid:pid, active:active },  
              dataType:"text",  
              success:function(data){  
                  //alert(data);  
                  fetch_data();  
              }  
          });  
      }  
  });

});


function fetch_data()  
{
  var req = new XMLHttpRequest();
  req.open("GET", '../api/server/get_correspondences.php',true);
  req.send();

  req.onload=function(){
    var json=JSON.parse( req.responseText );
    qrArray = json;

    //limit data called
    /*var son = arr.filter(function(val) {
          return (val.id >= 4);  
       });*/

    var html = "";
    html = "<div >"+  //class='table-responsive'
             "<table id='table_id' class='table table-bordered table-hover dataTable dtr-inline' style='table-layout: fixed; width: 100%;'>"+  //table table-bordered 
                "<thead><tr>"+
                     "<th>ID</th>"+  
                     "<th>Haus | Whg.</th>"+ 
                     "<th>Name</th>"+  
                     "<th>Level</th>"+  
                     "<th>Hash</th>"+  
                     "<th>Geräte</th>"+  
                     "<th>Aktiv</th>"+  
                     "<th>QR-Mail</th>"+  
                     "<th>QR-Mail #</th>"+  
                     "<th>QR-Code</th>"+  
                "</tr></thead>"; 

    //loop and display data
    //for (var key in json) {
      //if (json.hasOwnProperty(key)) {
        //alert(json[key].id);
    //}
    html += "<tbody>";

    if( Array.isArray(json) ) {
      json.forEach(function(val) {
          var keys = Object.keys(val);

          var memberState = "";
          if( val.isCouncil == 1)
            memberState = "Beirat, ";
          if( val.level == 1 )
            memberState += "Eigentümer";
          else
            memberState += "Mieter";

          html += "<tr>" +
                       "<td>" + val.cid + "</td>" +
                       "<td class='house_name'>#" + val.house_id + " | #" + val.flat + "<br>" + 
                                               val.house_city + ", " + val.house_street + " " + val.house_number + "<br>" +
                                               "<img src='images/weight.png' /> " + parseFloat( val.flat_weight/100 ).toFixed(2) + " - " + parseFloat( val.garage_weight/100 ).toFixed(2) + "</td>" +
                       "<td class='last_name'>" + val.last_name + " " + val.first_name;
                       
                       if( val.first_name2 != "" || val.last_name2 != "" )
                        html += "<br>" + val.last_name2 + " " + val.first_name2;
                       
                       if( val.company != "" )
                        html += "<br>" + val.company;

                       html += "<br>(" + val.pid + ")";

                       html += "</td><td class='level'>" + memberState + "</td>" +
                       "<td class='hash'>" + val.hash + "</td>" +
                       "<td class='token'>" + val.token_count + "</td>";
          
          if( val.active == 0)
            html +=    "<td><button type='button' name='delete_btn' class='btn btn-xs btn-danger btn_delete_client' data-pid='"+val.pid+"' data-active='"+val.active+"'>x</button></td>";
          else 
            html +=    "<td><button type='button' name='delete_btn' class='btn btn-xs btn-success btn_delete_client' data-pid='"+val.pid+"' data-active='"+val.active+"'>x</button></td>";  
          if( val.email == "" && val.email2 == "" )        
            html +=    "<td><img src='images/no_mail.png' /></td>"; 
          else {
            html +=    "<td>";
            if( val.email != "" )        
              html +=    "<a style='cursor:pointer;' title='"+val.email+"' onclick='sendQRMail("+val.pid+", \""+val.last_name+"\", \""+val.first_name+"\", \""+val.company+"\", \""+val.hash+"\", \""+val.email+"\")'><img src='images/mail.png' /></a>"; 
            if( val.email2 != "" ) 
              html +=    "<a style='cursor:pointer;' title='"+val.email2+"' onclick='sendQRMail("+val.pid+", \""+val.last_name2+"\", \""+val.first_name2+"\", \""+val.company+"\", \""+val.hash+"\", \""+val.email2+"\")'><img src='images/mail.png' /></a>"; 
            html +=    "</td>";
          }

          html +=    "<td class='qr_mail_sent'>" + val.qr_mail_sent + "</td>"; 
          	
          html +=    "<td><a href='#' onClick='qrPopup( \""+val.hash+"\" ); return false;' title='"+val.last_name+" "+val.first_name+" "+val.company+"''><img src='images/qr.png' /></a></td>";


          
          html +=  "</tr>";
      });
    }
    html += "</tbody></table>";

    //append in message class
    //document.getElementsByClassName('message')[0].innerHTML=html;
    $('#live_data').html(html); 

    $('#table_id').DataTable( {
        //responsive: true,
        //"autoWidth": false,
        /*"columns": [
          { "sType": 'numeric' },
          { "sType": 'numeric' },
          null,
          null,
          null,
          null,
          null,
          null
        ],*/
        "paging": true,
        "lengthChange": true,
        "searching": true,
        "ordering": true,
        "info": true,
        "autoWidth": true,
        "responsive": true,
        "lengthMenu": [[5, 10, 25, 50, -1], [5, 10, 25, 50, "All"]],
        "pageLength": 5,
        "columnDefs": [ {
            targets: 4,
            render: function ( data, type, row ) {
                  return data.length > 7 ? data.substr( 0, 5 ) +'…' : data;
            }
        }, {
            targets: [ 1 ],
            width: '15%', 
        }, {
            targets: [ 2 ],
            width: '15%', 
        } ],
        "order": [[ 1, "asc" ]]
    } );
  }
}


function qrPopup( hash ) { 
  //window.open('https://chart.googleapis.com/chart?chs=300x300&cht=qr&chl='+hash+'&choe=UTF-8','QR','toolbar=no,menubar=no,resizable=no,height=300,width=300');
  window.open('https://quickchart.io/qr?size=300&text='+hash,'QR','toolbar=no,menubar=no,resizable=no,height=300,width=300');
}


function sendQRMail( pid, last_name, first_name, company, hash, mail ) { 
  if(confirm("Möchtest Du den QR-Code dem Kunden mit der ID #"+pid+" via E-Mail an "+mail+" senden?"))  
  {  
    $.ajax({
        type: "POST",
        url:"../api/server/send_qr.php",  
        data:{ pid:pid, last_name:last_name, first_name:first_name, company:company, hash:hash, mail:mail },
        dataType: "text", //text/html
        success:function(data){
            alert( data );
        },
        error: function(err){
            alert("Fehler beim Senden der Mail: " + err.Message);
        }
    });
  }
}