var glob_phash = "";
var glob_name = "";
var glob_detailsTimer = 0;
var glob_resultTimer = 0;
var glob_decision = 1;
var glob_active_decision = 0;
var glob_no_of_decisions = 0;
var glob_creation_objects = 0;
var glob_edit_objects = 0;
var glob_maxDecisions = 30;
var glob_table_answer_id_page_length = 2;

$(document).ready(function() {

  if( glob_edit_objects == 0 ) {
    //DUPLICATE code -> edit button
    var arr ={ token:"hf90092h3ja83zA" };
    $.ajax({
        type: "POST",
        url:"../api/server/poll_get_hid_of_active_poll.php",  
        data: JSON.stringify(arr),
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
    }).done(function(hid){

      var arr ={ hid:hid, token:"hf90092h3ja83zA" };
      $.ajax({
          type: "POST",
          url:"../api/server/get_objects.php",  
          data: JSON.stringify(arr),
          contentType: 'application/json; charset=utf-8',
          dataType: 'json',
      }).done(function(objects){
        //console.log(objects);
        glob_edit_objects = objects;

        fetch_polls();
      });
      
    });
  }

  $(document).on('click', '.savePoll', function(){
      // reset errors before validating form
      resetErrorsInNewsform();

      if( validateform() )
        return;
     
      if(confirm("Bist du dir sicher, dass alle Eingaben korrekt sind, du nichts vergessen hast und die Abstimmung erstellt werden soll?"))  
      {
        var elements = document.getElementById("pollForm").elements;

        var arr ={ token:"hf90092h3ja83zA" };
        var j = 0;
        var error = 0;

        for (var i = 0, element; element = elements[i++];) {
            if( element.type === "select-multiple" )
              arr[j++] = $("#"+element.id).val();
            else if( (element.type === "text" || element.type === "textarea" || (element.type === "radio") && element.checked) && element.id != "house_name" ) {
              //skip all elements with no value
              if( element.value !== "" ) {
                arr[j++] = element.value;
              }
              else { //for textareas (Beschlüsse) inform user that he missed one to fill out
                if( (element.type === "textarea") ) {
                  alert("Manche Beschlüsse sind leer und benötigen Inhalt, bitte kontrolliere alle Textfelder!");
                  error++;
                  return;
                }
              }
            }
        }

        if( error > 0 )
          return;

        //console.log( arr );

        $.ajax({
            type: "POST",
            url:"../api/server/poll_create.php",  
            data: JSON.stringify(arr),
            contentType: 'application/json; charset=utf-8',
            dataType: 'json',
            success:function(data){ 
                //alert(data);  
                fetch_polls();
                location.reload();
            }  
        });  
      }
  });

  $(document).on('click', '.saveActiveDecision', function(){
     
      var decision = document.getElementById("activeDecision").value;

      if( decision === undefined || decision < 1 || decision > glob_no_of_decisions )
        return;

      var phash = glob_phash;
      var arr = { token:"hf90092h3ja83zA", decision:decision, phash:phash };

      $.ajax({
          type: "POST",
          url:"../api/server/poll_activate_decision.php",  
          data: JSON.stringify(arr),
          contentType: 'application/json; charset=utf-8',
          dataType: 'json',
          success:function(data){
            changeResultDecision( decision );
          }  
      });  
  });

  $(document).on('click', '.btn_toggle_active', function(){
      var phash = $(this).data("phash"); 
      var active = $(this).data("active");
      var activeStr = "aktiv";

      if( active ) activeStr = "inaktiv";

      if(confirm("Bist du Dir sicher, dass du diese Abstimmung umschalten möchtest (phash: "+phash+", neuer Status: "+activeStr+")?"))  
      {  
          var arr ={ phash:phash, active:active, token:"hf90092h3ja83zA" };

          $.ajax({
              type: "POST",
              url:"../api/server/poll_active.php",  
              data: JSON.stringify(arr),
              contentType: 'application/json; charset=utf-8',
              dataType: 'json',
              success:function(data){  
                  if( data == 0 )
                    alert( "Vorsicht, es darf nur eine Abstimmung aktiv sein!" );
                  else if( data == 2 )
                    alert( "Es ist ein Fehler aufgetreten!" );
                  else {
                    window.location.reload();
                  }
              }  
          });  
      }  
  });

  //table edit button
  $(document).on('click', "[id^='table_poll_id'] .editButton", 'tr', function (x) {
    var selected_hid = $(this).data("hid");
    var selected_name = $(this).data("name");
    var tableID = $(this).closest('table').attr('id');    // id of the table

    //set object dropdown
    var arr ={ hid:selected_hid, token:"hf90092h3ja83zA" };
    $.ajax({
        type: "POST",
        url:"../api/server/get_objects.php",  
        data: JSON.stringify(arr),
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
    }).done(function(objects){
      //console.log(objects);
      glob_edit_objects = objects;

      fetch_polls();

      //TODO correct objects are not loaded correctly at first time
      //if( glob_edit_objects == 0 )
      //  return;

      //get table and set name
      var that = $( '#'+tableID )[0].altEditor;
      that.language.edit.title = selected_name;

      //show edit
      that._openEditModal();
      $('#altEditor-edit-form-' + that.random_id)
                  .off('submit')
                  .on('submit', function (e) {
                      e.preventDefault();
                      e.stopPropagation();
                      that._editRowData();
                  });

      //on close | sadly this is not working :(
      /*$('#altEditor-edit-form-' + that.random_id).on("hidden.bs.modal", function () {
          console.log("closed");
      });*/
    })
  });

  //reset glob_edit_objects if edit modal is closed
  $(document).on('click', '[data-dismiss="modal"]', function(){
    //TODO check if this is also the edit modal
    glob_edit_objects = 0;
  });

}); //document ready end


function fetch_polls( edit_callback ) {
  var arr ={ token:"hf90092h3ja83zA" };

  $.ajax({
      type: "POST",
      url:"../api/server/poll_get_all.php",  
      data: JSON.stringify(arr),
      contentType: 'application/json; charset=utf-8',
      dataType: 'json',
      })
      .done(function(entries){

        var html = "";
        html = "<div >"+
                 "<table id='table_poll_id' class='table table-bordered table-hover dataTable dtr-inline' style='table-layout: fixed; width: 100%;'>"+  //table table-bordered 
                    "<thead><tr>"+
                         "<th>Datum</th>"+  
                         "<th>Name</th>"+ 
                         "<th>WEG</th>"+  
                         "<th>Passwort</th>"+  
                         "<th>Beschlüsse</th>"+  
                         "<th>Aktiv</th>"+  
                         "<th>Auswählen</th>";

        //Decisions + Weight + Object
        for(var i=1; i<31; i++) {
          html +=        "<th class='none'>["+i+"] Beschluss</th>"+
                         "<th class='none'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Gewichtung (B-"+i+")</th>" +
                         "<th class='none'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Objekt (B-"+i+")</th>";
        }

        html +=          "<th class='none'>phash</th>"+
                    "</tr></thead>"; 
        html += "<tbody>";

        if( Array.isArray(entries) ) {
          entries.forEach(function(val) {
            var keys = Object.keys(val);

            var editButtonDisabled = "disabled";

            if( glob_phash === val.phash )
              editButtonDisabled = "";

            html += "<tr>"+
                         "<td class='date'>" + val.date + "</td>" +
                         "<td class='title'>" + val.name + "</td>" +
                         "<td class='text'>" + val.house_name + "</td>" +
                         "<td class='house'>" + val.pass + "</td>" +
                         "<td class='edit'>" + val.no_of_decisions + "<button data-hid='"+val.hid+"' class='editButton fas fa-edit btn btn-info btn_icon' data-name='"+val.name+"' title='Erst Abstimmung auswählen!' "+editButtonDisabled+" href='#'' style='float:right;'></a></td>";
            
            //active button
            if( val.active == 0)
              html +=    "<td class='text'><center><button type='button' name='delete_btn' class='btn btn btn-danger btn_toggle_active btn_icon' data-phash='"+val.phash+"' data-active='"+val.active+"'><i class='nav-icon fas fa-times'></i></button></center></td>";
            else
              html +=    "<td class='text'><center><button type='button' name='delete_btn' class='btn btn btn-success btn_toggle_active btn_icon' data-phash='"+val.phash+"' data-active='"+val.active+"'><i class='nav-icon fas fa-check'></i></button></center></td>";
            
            //details/auswählen button
            html += "<td class='text'><center><button data-hid='"+val.hid+"' type='button' class='btn btn-light btn_icon' data-name='"+val.name+"' data-phash='"+val.phash+"' data-no='"+val.no_of_decisions+"' onclick='showDetails(this, 1);'><i class='nav-icon fas fa-play'></i></button></center></td>";

            html += fetch_polls_create_td( val.decision_1 );
            html += fetch_polls_create_td( val.decision_2 );
            html += fetch_polls_create_td( val.decision_3 );
            html += fetch_polls_create_td( val.decision_4  );
            html += fetch_polls_create_td( val.decision_5  );
            html += fetch_polls_create_td( val.decision_6  );
            html += fetch_polls_create_td( val.decision_7  );
            html += fetch_polls_create_td( val.decision_8  );
            html += fetch_polls_create_td( val.decision_9  );
            html += fetch_polls_create_td( val.decision_10  );
            html += fetch_polls_create_td( val.decision_11  );
            html += fetch_polls_create_td( val.decision_12  );
            html += fetch_polls_create_td( val.decision_13  );
            html += fetch_polls_create_td( val.decision_14  );
            html += fetch_polls_create_td( val.decision_15  );
            html += fetch_polls_create_td( val.decision_16  );
            html += fetch_polls_create_td( val.decision_17  );
            html += fetch_polls_create_td( val.decision_18  );
            html += fetch_polls_create_td( val.decision_19  );
            html += fetch_polls_create_td( val.decision_20  );
            html += fetch_polls_create_td( val.decision_21  );
            html += fetch_polls_create_td( val.decision_22  );
            html += fetch_polls_create_td( val.decision_23  );
            html += fetch_polls_create_td( val.decision_24  );
            html += fetch_polls_create_td( val.decision_25  );
            html += fetch_polls_create_td( val.decision_26  );
            html += fetch_polls_create_td( val.decision_27  );
            html += fetch_polls_create_td( val.decision_28  );
            html += fetch_polls_create_td( val.decision_29  );
            html += fetch_polls_create_td( val.decision_30  );
            html += "<td class='text'>" + val.phash + "</td>";
          });
        }

        html += "</tbody></table>";

        //append in message class
        $('#live_poll').html(html);

        // create set of data for objects
        var dict_objs = {}; 
        if( glob_edit_objects != undefined && glob_edit_objects != 0 ) {
            glob_edit_objects.forEach(function(object){
                dict_objs[ object.oid ] = object.title;
            })
        }

        // create set of data for objects
        var dict_weight = {}; 
        dict_weight[ 'default' ] = get_Weight_String( 'default' );
        dict_weight[ 'garage' ] = get_Weight_String( 'garage' );
        dict_weight[ 'flat' ] = get_Weight_String( 'flat' );

        //https://github.com/KasperOlesen/DataTable-AltEditor
        $('#table_poll_id').DataTable( {
            "paging": true,
            "lengthChange": true,
            "searching": true,
            "ordering": true,
            "info": true,
            "autoWidth": true,
            "responsive": true,
            "lengthMenu": [[3, 5, 10, 25, 50, -1], [3, 5, 10, 25, 50, "All"]],
            "pageLength": 3,
            "ordering": false,
            "closeModalOnSuccess": true,
            "columnDefs": [ {
                targets: [ 0 ],
                width: '15%',
                type: "readonly",
            }, {
                targets: [ 1 ],
                width: '30%', 
            }, {
                targets: [ 2 ],
                type: "readonly",
            }, {
                targets: [ 4, 5, 6 ],
                type: "hidden",
            }, {
                targets: [ 7, 10, 13, 16, 19, 22, 25, 28, 31, 34, 37, 40, 43, 46, 49, 52, 55, 58, 61, 64, 67, 70, 73, 76, 79, 82, 85, 88, 91, 94 ],
                type: "textarea",
            }, {
                targets: [ 8, 11, 14, 17, 20, 23, 26, 29, 32, 35, 38, 41, 44, 47, 50, 53, 56, 59, 62, 65, 68, 71, 74, 77, 80, 83, 86, 89, 92, 95 ],
                type: "select",
                options: dict_weight,
                render : function (data, type, row, meta) {
                  if (data == null || row == null) 
                    return null;

                  return get_Weight_String( data );
                },
            }, {
                targets: [ 9, 12, 15, 18, 21, 24, 27, 30, 33, 36, 39, 42, 45, 48, 51, 54, 57, 60, 63, 66, 69, 72, 75, 78, 81, 84, 87, 90, 93, 96 ],
                type: "select",
                multiple: true,
                select2 : { width: "100%"},
                options: dict_objs, //different per row
                render : function (data, type, row, meta) {
                  if (data == null || row == null) 
                    return null;

                  //remove brackets of e.g. [123456,1234567]
                  var data_temp = data.replace(/[\[\]']+/g,'')

                  //making integer array out of the string list
                  var data_array = data_temp.split(',').map(entry => parseInt(entry)).filter(entry => typeof entry ==='number');

                  //map from 123456 to "Test City 1b"
                  var result = data_array.map(function(x) { return dict_objs[x];}); 
                  return result.join();
                },
                /*editorOnChange : function(event, altEditor) {
                    //console.log(event, altEditor);
                    //var data = $(event.currentTarget).val();

                    //currentTarget.label / value / text
                    //due to hid -> ajax for objects
                    if (country == "Italy"){
                        $(altEditor.modal_selector).find("#alteditor-row-town").show();
                        $.ajax({
                            url: url_ws_mock_prefix + 'mock_svc_italy.json',
                            type: 'GET',
                            success: function(options) {
                                console.log(options);
                                var town = $(altEditor.modal_selector).find('#town');
                                altEditor.reloadOptions(town, options);
                            }
                        });
                    } else {
                        $(altEditor.modal_selector).find("#alteditor-row-town").hide();
                    }
                    //console.log(options);
                    //var objs = $(altEditor.modal_selector).find('#9');
                    //altEditor.reloadOptions(objs, ["Alle","Test City 1a","Test City 1b"]);
                },*/
            }, {
                targets: [ -1 ],
                type: "readonly",
            }],
            sPaginationType: "full_numbers",
            dom: 'Bfrtip', // Needs button container
            select: {
                style: 'single',
                toggleable: false
            },
            language: {
                url: 'plugins/datatables/translations/German.json',
                altEditorUrl: 'plugins/datatables/translations/DE.json'
            },
            responsive: true,
            altEditor: true,
            buttons: [],
            onEditRow: function(datatable, rowdata, success, error) {
                //console.log( rowdata );
                //return;
                rowdata["token"] = "hf90092h3ja83zA"; //security mechansim
                $.ajax({
                    type: "POST",
                    url:"../api/server/poll_edit.php",  
                    data: JSON.stringify(rowdata),
                    contentType: 'application/json; charset=utf-8',
                    dataType: 'json',
                    success:function(data){
                        console.log(data);
                        fetch_polls();

                        // instead of refresh, close dialog manually
                        //location.reload();
                        datatable.internalCloseDialog(datatable.modal_selector);
                    }  
                }); 
            },
            /*drawCallback: function( settings ) { //on draw done
              if( edit_callback !== undefined && edit_callback !== 0 ) {
                edit_callback();
              }
            },*/
            "bDestroy": true
        });
  })
}

function get_Weight_String( weight ) {
  if( weight === "garage" )
    return "nur Garage";
  else if( weight === "flat" )
    return "nur Whg.";
  else
    return "Garage + Whg.";
}

//helper for fetch_polls (decision, weight + objects)
function fetch_polls_create_td( decision_object ) {
  var content = "";

  content += "<td class='text'>" + decision_object['decision'] + "</td>";
  content += "<td class='text'>" + decision_object['weight'] + "</td>";
  if( decision_object['object'] !== undefined && decision_object['object'] !== "0" ) {
    var first = true;
    content += "<td class='text'>["
    decision_object['object'].forEach(function(obj){
      if(!first)
        content += ","; 
      else
        first = false;
       
       content += ""+ obj['oid'];
    })
    content += "]</td>";
  }
  else
    content += "<td class='text'></td>";

  return content;
}


// Close the dropdown if the user clicks outside of it
window.onclick = function(event) {
  if (!event.target.matches('.dropbtn') && !event.target.matches('.dropbtn2')) {

    $('#housesInput').val("");

    var dropdowns = document.getElementsByClassName("dropdown-content");
    for (var i = 0; i < dropdowns.length; i++) {
      var openDropdown = dropdowns[i];
      if (openDropdown.classList.contains('show')) {
        openDropdown.classList.remove('show');
      }
    }
  }
}

/* When the user clicks on the button,
toggle between hiding and showing the dropdown content */
function dropDownHouses() {
  document.getElementById("houseDropDown").classList.toggle("show");

  $('#housesInput').val("");

  $.ajax({
      type: "POST",
      url:"../api/server/get_houses.php",  
      data:{},  
      dataType:"text",
  }).done(function(houses){
    //console.log(houses);
    houses = JSON.parse(houses);
    $('#houses').empty();
    houses.forEach(function(house){
      $('#houses').append('<a style="cursor:pointer;" onclick="useHouse(' + house.hid + ', \'' + house.name + '\')">' + house.hid + ' | ' + house.name + '</a>');
    })
  })
}

function useHouse(houseId, houseName) {
  // set house id and name
  $('#house_id').val(houseId);
  $('#house_name').val(houseName);

  //enable buttons
  $('#add_decision').prop('disabled', false);
  $('#save_poll').prop('disabled', false);

  //set object dropdown
  var arr ={ hid:$('#house_id').val(), token:"hf90092h3ja83zA" };
  $.ajax({
      type: "POST",
      url:"../api/server/get_objects.php",  
      data: JSON.stringify(arr),
      contentType: 'application/json; charset=utf-8',
      dataType: 'json',
  }).done(function(objects){
    //console.log(objects);
    glob_creation_objects = objects;
  })
}

function filterHouses() {
    var input, filter, ul, li, a, i;
    input = document.getElementById("housesInput");
    filter = input.value.toUpperCase();
    div = document.getElementById("houseDropDown");
    a = div.getElementsByTagName("a");
    for (i = 0; i < a.length; i++) {
        if (a[i].innerHTML.toUpperCase().indexOf(filter) > -1) {
            a[i].style.display = "";
        } else {
            a[i].style.display = "none";
        }
    }
}

function validateform() {
  var err = false;

  //set red border if pollName not set
  if( $("input#pollName").val() == "" ) 
  {
    $('input#pollName').css('border', '2px solid red');
    err = true;
  }
  //set red border if pollPw not set
  if( $("input#pollPw").val() == "" ) 
  {
    $('input#pollPw').css('border', '2px solid red');
    err = true;
  }
  //set red border if ...
  if( $("input#house_id").val() == "" ) 
  {
    $('.dropdown').css('border', '2px solid red');
    err = true;
  }
  return err;
}

function resetErrorsInNewsform() {
  //reset error css first
  $('#pollName').css('border', '');
  $('#pollPw').css('border', '');
  $('.dropdown').css('border', '');
}

function showDetails( buttonObject ) {
  $('.decision_detail').css("display", "flex");

  glob_phash=$(buttonObject).data("phash");
  glob_name=$(buttonObject).data("name");
  glob_no_of_decisions=$(buttonObject).data("no");

  //$(buttonObject).closest("tr").find(".editButton").prop('disabled', false);

  //scroll down until details section
  //var element = document.getElementById('detail_area');
  //var offsetPosition = element.getBoundingClientRect().top - 80; //minus headerOffset;
  //window.scrollTo({ top: offsetPosition, behavior: "smooth" });

  // get correct enum items for objects like 48a, 48b ...
  var selected_hid = $(buttonObject).data("hid");
  //set object dropdown
  var arr ={ hid:selected_hid, token:"hf90092h3ja83zA" };
  $.ajax({
      type: "POST",
      url:"../api/server/get_objects.php",  
      data: JSON.stringify(arr),
      contentType: 'application/json; charset=utf-8',
      dataType: 'json',
  }).done(function(objects){
    //console.log(objects);
    glob_edit_objects = objects;
    fetch_polls();
  })

  showOverview( 1 );
  showResult( 1 );
  showProxy( 1 );
}

function showOverview( button_pressed ) {

  if( button_pressed == 1)
    clearInterval( glob_detailsTimer );

  var arr ={ phash:glob_phash, token:"hf90092h3ja83zA" };

  $.ajax({
      type: "POST",
      url:"../api/server/poll_get_answers.php",  
      data: JSON.stringify(arr),
      contentType: 'application/json; charset=utf-8',
      dataType: 'json',
      })
      .done(function(entries){

        $('#answers_title').html( "Übersicht Beschlüsse von Abstimmung: <br><b>" + glob_name + "</b>" );

        var html = "";
        var firstTime = true;

        if( Array.isArray(entries) ) {
          entries.forEach(function(val) {
            var keys = Object.keys(val);

            if( firstTime ) {
              firstTime = false;

              html = "<div >"+  //class='table-responsive'
                       "<table id='table_answer_id' class='table table-bordered table-hover dataTable dtr-inline' style='table-layout: fixed; width: 99%;'>"+  //table table-bordered 
                          "<thead><tr>"+
                               "<th>Benutzer</th>";

              for( var i=1; i<=glob_no_of_decisions; i++ ) {
                if( i == glob_active_decision )
                  html += "<th class='bg-primary'>"+i+"</th>";
                else
                  html += "<th>"+i+"</th>";
              }

              html +=   "</tr></thead><tbody>";
            }

            html += "<tr>";
            if( val.last_name == "" && val.first_name == "")
              html += "<td class='title'>" + val.company + "</td>";
            else  
              html += "<td class='title'>" + val.last_name + " " + val.first_name + "</td>";

            var answer_inc = 1
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_1  ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_2  ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_3  ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_4  ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_5  ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_6  ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_7  ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_8  ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_9  ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_10 ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_11 ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_12 ); answer_inc++;   
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_13 ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_14 ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_15 ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_16 ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_17 ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_18 ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_19 ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_20 ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_21 ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_22 ); answer_inc++;   
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_23 ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_24 ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_25 ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_26 ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_27 ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_28 ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_29 ); answer_inc++;
            html += showOverviewCreateTD( glob_no_of_decisions, answer_inc, val.answer_30 );
          });
          
          html += "</tr></tbody></table>";
        }
        //no json array, no data
        else {
        }

        if(html == "")
          $('#detail_area').css("display", "none");
        else
          $('.decision_detail').css("display", "flex");
        
        //append in message class
        $('#live_poll_answers').html(html);

        $('#table_answer_id').DataTable( {
            "paging": true,
            "lengthChange": true,
            "searching": false,
            "ordering": false,
            "info": true,
            "autoWidth": true,
            "responsive": true,
            "lengthMenu": [[0, 1, 2, 5, 10, 25, 50, -1], [0, 1, 2, 5, 10, 25, 50, "All"]],
            "pageLength": glob_table_answer_id_page_length,
            "columnDefs": [ {
                targets: [ 0 ],
                width: '20%', 
            }],
            drawCallback: function () {
              var api = this.api();
              var len = api.page.len();
              glob_table_answer_id_page_length = len;
            }
        } );

        //create timer
        var sec = 2;
        glob_detailsTimer = setInterval(function(){
          sec--;
          if (sec < 0) {
            clearInterval( glob_detailsTimer );
            showOverview( 0 );
          }
        }, 1000);       
  })
}

function showOverviewCreateTD( max, cur, answerX ) {
  if( max >= cur )
    return "<td class='text answer" + answerX +"'>" + answerX + "</td>"
  return "";
}

function changeResultDecision( val ) {
  if( val === undefined) {
    var selected_decision = $('#showDecision').val();
    if( selected_decision > 0 && selected_decision <= glob_no_of_decisions )
      glob_decision = $('#showDecision').val();
    else 
      glob_decision = 1;
  }
  else
    glob_decision = val;
}

function showResult( button_pressed ) {

  if( button_pressed == 1)
    clearInterval( glob_resultTimer );

  var arr ={ phash:glob_phash, token:"hf90092h3ja83zA", decision:glob_decision };

  $.ajax({
      type: "POST",
      url:"../api/server/poll_get_results.php",
      data: JSON.stringify(arr),
      contentType: 'application/json; charset=utf-8',
      dataType: 'json',
      })
      .done(function(entries){

        var htmlResult = "";
        htmlResult = "<div >"+  //class='table-responsive'
                 "<table id='table_result_id' class='table table-bordered table-hover dataTable dtr-inline' style='table-layout: fixed; width: 99%;'>"+  //table table-bordered 
                    "<thead><tr>"+
                         "<th>Benutzer</th>"+  
                         "<th>Entscheidung</th>"+ 
                         "<th>Gewichtung</th>"+ 
                         "<th>Stimmen</th>"+ 
                    "</tr></thead>"; 
        htmlResult += "<tbody>";

        var noOfVoters = 0;
        var noOfAgree = 0;
        var noOfDecline = 0;
        var noOfAbstain = 0;

        var weightMax = 0;
        var weightOfAgree = 0;
        var weightOfDecline = 0;
        var weightOfAbstain = 0;

        var currentDecision = "";
        var currentActiveDecision = 0;

        if( entries != null && entries != undefined && entries.results != undefined ) {
         
          noOfVoters = entries.results['noOfVoters'];
          noOfAgree = entries.results['noOfAgree'];
          noOfDecline = entries.results['noOfDecline'];
          noOfAbstain = entries.results['noOfAbstain'];

          weightMax = entries.results['weight_max'];
          weightOfAgree = entries.results['weight_agree'];
          weightOfDecline = entries.results['weight_decline'];
          weightOfAbstain = entries.results['weight_abstain'];

          Object.keys(entries).forEach(function (key){
            val = entries[key];

            if( key == "results" )
                return;

            if( currentDecision == "" )
              currentDecision = val.decision_X;

            if( currentActiveDecision == 0 )
                currentActiveDecision = val.active_decision;

            htmlResult += "<tr>";

            if( val.last_name == "" && val.first_name == "")
              htmlResult += "<td class='title'>" + val.company + "</td>";
            else  
              htmlResult += "<td class='title'>" + val.last_name + " " + val.first_name + "</td>";
                         
            htmlResult += "<td class='text answer" + val.answer_X +"'>" + val.answer_X + "</td>" +
                          "<td class='text'>" + parseFloat(val.weight/100).toFixed(2) +"</td>" +
                          "<td class='text'>" + val.counts + "</td>";
          });
        }
        //no json array, no data
        else {
        }
        
        htmlResult += "</tbody></table>";

        //update current active_decision
        $('#current_active_decision').html( currentActiveDecision );
        glob_active_decision = currentActiveDecision;

        //change title of card
        $('#result_title').html( "Angezeigter Beschluss: <span id='current_displayed_decision'>" + glob_decision + "</span><br>" + currentDecision + "" );

        //append in message class
        $('#live_poll_result').html(htmlResult);

        //update graph also
        showGraph( glob_name, currentDecision, noOfVoters, noOfAgree, noOfDecline, noOfAbstain, weightMax, weightOfAgree, weightOfDecline, weightOfAbstain );

        $('#table_result_id').DataTable( { 
            "paging": false,
            "lengthChange": true,
            "searching": false,
            "ordering": false,
            "info": true,
            "autoWidth": true,
            "responsive": true,
            "lengthMenu": [[5, 10, 25, 50, -1], [5, 10, 25, 50, "All"]],
            "pageLength": -1,
            "columnDefs": [ {
                targets: [ 0 ],
                width: '40%', 
            }],
        } );

        //create timer
        var sec = 2;
        glob_resultTimer = setInterval(function(){
          sec--;
          if (sec < 0) {
            clearInterval( glob_resultTimer );
            showResult( 0 );
          }
        }, 1000);
        
  })
}

// hack to fix jquery 3.6 focus security patch that bugs auto search in select-2
$(document).on('select2:open', () => {
    $('body div.modal.fade.altEditor-modal.reveal.show')[0].removeAttribute('tabindex');
    document.querySelector('.select2-search__field').focus();
});

function showProxy( button_pressed ) {

  var arr = { phash:glob_phash, token:"hf90092h3ja83zA" };

  $('#proxy_title').html( "Erstelle Vollmacht für <b>" + glob_name + "</b>" );

  $.when(
    $.ajax({
      type: "POST",
      url:"../api/server/poll_proxy_get.php",
      data: JSON.stringify(arr),
      contentType: 'application/json; charset=utf-8',
      dataType: 'json',
      }), 
    $.ajax({
      type: "POST",
      url:"../api/server/poll_proxy_get_of_house.php",
      data: JSON.stringify(arr),
      contentType: 'application/json; charset=utf-8',
      dataType: 'json',
      }))
    .then(function (resp1, resp2) {

        entriesTable = resp1[0];
        entriesCreate = resp2[0];

        var dataSet = [];

        // create data for poxy table (get)
        if( entriesTable != undefined ) {
            Object.keys(entriesTable).forEach(function (key){
            val = entriesTable[key];

            dataSet.push( {id:val.id, absentee:val.absentee, agent:val.agent, phash:val.phash} );
          });
        }

        // create data for poxy creation of new data set (create)
        var dict_proxy = {}; 
        if( entriesCreate != undefined ) {
            Object.keys(entriesCreate).forEach(function (key){
            val = entriesCreate[key];

            dict_proxy[ val.pid ] = val.last_name + " " + val.first_name + " " + val.company;
          });
        }

        var columnDefs = [{
          data: "id",
          title: "Id",
          //type: "readonly"
          disabled: true
        },
       {
          data: "agent",
          title: "Stellvertreter",
          required: true,
          type: "select",
          options: dict_proxy,
          select2 : { width: "100%"}
        },
        {
          data: "absentee",
          title: "Abwesender",
          required: true,
          type: "select",
          options: dict_proxy,
          select2 : { width: "100%"}
        },
       {
          data: "phash",
          title: "PHash",
          value: glob_phash,
          disabled: true
        },
       {
          data: null,
          title: "Löschen",
          name: "Actions",
          render: function (data, type, row, meta) {
            return '<a class="delbutton fa fa-minus-square btn btn-danger"></a>';
          },
          disabled: true
        } 
        ];

        var proxyTable = $('#proxy_table').DataTable({
          "sPaginationType": "full_numbers",
          data: dataSet,
          columns: columnDefs,
          dom: 'Bfrtip',        // Needs button container
          select: {
              style: 'single',
              toggleable: false
          },
          language: {
              url: 'plugins/datatables/translations/German.json',
              altEditorUrl: 'plugins/datatables/translations/DE.json'
          },
          responsive: true,
          altEditor: true,     // Enable altEditor
          buttons: [],          // no buttons, however this seems compulsory
          onAddRow: function(datatable, rowdata, success, error) {
              //console.log( rowdata );
              rowdata["token"] = "hf90092h3ja83zA"; //security mechansim
              $.ajax({
                  type: "POST",
                  url:"../api/server/poll_proxy_create.php",  
                  data: JSON.stringify(rowdata),
                  contentType: 'application/json; charset=utf-8',
                  dataType: 'json',
                  success:function(data){ 
                      //alert(data);  
                      //fetch_polls();
                      location.reload();
                  },
                  error: function (data) {
                    //alert("PHP error: " + data.responseText);
                  }
              }); 
          },
          onDeleteRow: function(datatable, rowdata, success, error) {
              //console.log( rowdata );
              rowdata["token"] = "hf90092h3ja83zA"; //security mechansim
              $.ajax({
                  type: "POST",
                  url:"../api/server/poll_proxy_delete.php",  
                  data: JSON.stringify(rowdata),
                  contentType: 'application/json; charset=utf-8',
                  dataType: 'json',
                  success:function(data){ 
                      //alert(data);  
                      //fetch_polls();
                      location.reload();
                  }  
              }); 
          },
          "bDestroy": true
        });

        // Delete
        $(document).on('click', "[id^='proxy_table'] .delbutton", 'tr', function (x) {
          var tableID = $(this).closest('table').attr('id');    // id of the table
          var that = $( '#'+tableID )[0].altEditor;
          that._openDeleteModal();
          $('#altEditor-delete-form-' + that.random_id)
                      .off('submit')
                      .on('submit', function (e) {
                          e.preventDefault();
                          e.stopPropagation();
                          that._deleteRow();
                      });
          x.stopPropagation(); //avoid open "Edit" dialog
        });

        // Add row
        $('#proxy_addbutton').on('click', function () {
          var that = $( '#proxy_table' )[0].altEditor;
          that._openAddModal();
          $('#altEditor-add-form-' + that.random_id)
                      .off('submit')
                      .on('submit', function (e) {
                          e.preventDefault();
                          e.stopPropagation();
                          that._addRowData();
                      });
        });    
  });
}


function showGraph( name, currentDecision, noOfVoters, noOfAgree, noOfDecline, noOfAbstain, weightMax, weightOfAgree, weightOfDecline, weightOfAbstain ) {

  var htmlGraph = "Es haben <b>" + (noOfAgree+noOfDecline+noOfAbstain) + "</b> abgestimmt:";
  htmlGraph += "<br>- JA: <b>" + noOfAgree + "</b> ( " + parseFloat(weightOfAgree/100).toFixed(2) + " /1000stel )";
  htmlGraph += "<br>- NEIN: <b>" + noOfDecline + "</b> ( " + parseFloat(weightOfDecline/100).toFixed(2) + " /1000stel )";
  htmlGraph += "<br>- Enthalten: <b>" + noOfAbstain + "</b> ( " + parseFloat(weightOfAbstain/100).toFixed(2) + " /1000stel )";

  $('#graph_title').html( "Angezeigter Beschluss: #" + glob_decision );
  $('#live_graph_result').html(htmlGraph);

  // Load the Visualization API and the corechart package.
  google.charts.load('current', { 'packages': ['corechart'] });

  // Set a callback to run when the Google Visualization API is loaded.
  google.charts.setOnLoadCallback(drawChart);

  // Callback that creates and populates a data table,
  // instantiates the pie chart, passes in the data and
  // draws it.
  function drawChart() {

      // Create the data table.
      var dataVotes = new google.visualization.DataTable();
      dataVotes.addColumn('string', 'Answer');
      dataVotes.addColumn('number', 'Quotes');
      dataVotes.addRows([
          ['JA', noOfAgree],
          ['NEIN', noOfDecline],
          ['Enthalten', noOfAbstain],
      ]);

      // Create the rating data table.
      var dataRatings = new google.visualization.DataTable();
      dataRatings.addColumn('string', 'Answer');
      dataRatings.addColumn('number', 'Quotes');
      dataRatings.addRows([
          ['JA', parseFloat(weightOfAgree/100)],
          ['NEIN', parseFloat(weightOfDecline/100)],
          ['Enthalten', parseFloat(weightOfAbstain/100)],
      ]);

      // Set chart options
      var options = {
          chartArea:{width:'100%',height:'100%'},
          backgroundColor: '#343a40',
          colors: ['#00bc8c', '#e74c3c', '#232323'],
          'is3D': true,
          'width': 400,
          'height': 300,
          legend: {
              position: 'none',
              labeledValueText: 'both',
              textStyle: {
                  fontSize: 14
              }
          },
      };

      // Instantiate and draw our chart, passing in some options.
      var chartVotes = new google.visualization.PieChart(document.getElementById('poll-chart-votes'));
      chartVotes.draw(dataVotes, options);

      var chartRatings = new google.visualization.PieChart(document.getElementById('poll-chart-ratings'));
      chartRatings.draw(dataRatings, options);
    }
}


async function showResultNewPage() {

  $('#print_decisions').prop('disabled', true);

  var html = "";
  var plottedPage = false;
  
  for( var i=1; i<=glob_maxDecisions; i++ ) {

    await delayTimer(100);

    var arr ={ phash:glob_phash, token:"hf90092h3ja83zA", decision:i };
    $.ajax({
        type: "POST",
        url:"../api/server/poll_get_results.php",
        data: JSON.stringify(arr),
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
        })
        .done(function(entries){

            if( entries == null || entries == undefined || entries.length == 0 )
              return;

            //TODO duplicate code
            var noOfVoters = entries.results['noOfVoters'];
            var noOfAgree = entries.results['noOfAgree'];
            var noOfDecline = entries.results['noOfDecline'];
            var noOfAbstain = entries.results['noOfAbstain'];

            var weightMax = entries.results['weight_max'];
            var weightOfAgree = entries.results['weight_agree'];
            var weightOfDecline = entries.results['weight_decline'];
            var weightOfAbstain = entries.results['weight_abstain'];

            var currentDecision = "";
            var currentActiveDecision = 0;

            Object.keys(entries).forEach(function (key){
            val = entries[key];

            if( key == "results" )
                return;

              currentDecisionStr = val.decision_X;
              currentDecision = i-1; //because of i++ which does its job meanwhile
            });

            //create content
            if( currentDecisionStr != "" ) {
              var htmlStr = "Beschluss " + currentDecision + ": " + currentDecisionStr;
              htmlStr += "<br>JA: <b>" + noOfAgree + "</b> ( " + parseFloat(weightOfAgree/100).toFixed(2) + " /1000stel )";
              htmlStr += "<br>NEIN: <b>" + noOfDecline + "</b> ( " + parseFloat(weightOfDecline/100).toFixed(2) + " /1000stel )";
              htmlStr += "<br>Enthalten: <b>" + noOfAbstain + "</b> ( " + parseFloat(weightOfAbstain/100).toFixed(2) + " /1000stel )";
              html += htmlStr + "<br><br>";
            }

            //first via for-loop we count to max_decision (+1)
            //then we recursively (via callback) we reduce the number (until 1)
            //i--;
            console.log( "INFO: Printed decision: " + currentDecision)

            //this should only be done once (i would be 31 at the end and then all the callbacks would come back...)
            if( i >= 30 /*i == 1*/ && !plottedPage ) { 
              plottedPage = true;
              $('#print_decisions').prop('disabled', false);
              var win = window.open("", "Title", "toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=600,height=800,top="+(screen.height-200)+",left="+(screen.width-200));
              win.document.body.innerHTML = html;
            }
        })
  }
}



/*************************************** CREATE POLL start /***************************************/
  //$(function () {
      var count = 0;
      function addItem() {
          // disable house dropdown
          $('#dropdown_houses').prop('disabled', true);

          var definedText = "";

          var text1 = "Die Nachschüsse bzw. Anpassungen der beschlossenen Vorschüsse aus den Einzelabrechnungen für das Jahr "+(new Date().getFullYear()-1)+" vom 01.02."+new Date().getFullYear()+" werden genehmigt und die Nachschüsse fällig gestellt. Der Einzug der Forderungen erfolgt zum 05.03."+new Date().getFullYear()+". Etwaige Guthaben der Eigentümer aufgrund der Anpassungen der beschlossenen Vorschüsse hat der Verwalter – sofern kein anderweitiger Rückstand besteht – zu diesem Termin auszukehren.";
          var text2 = "Die Vorschüsse aus den Einzelwirtschaftsplänen für das Jahr "+new Date().getFullYear()+" vom 01.02."+new Date().getFullYear()+" werden genehmigt. Die Vorschüsse aus den Einzelwirtschaftsplänen für das Jahr "+new Date().getFullYear()+" gelten so lange, bis ein neuer Beschluss über Vorschüsse aus Einzelwirtschaftsplänen gefasst wird.";
          var text3 = "Nachdem die Jahresabrechnung anerkannt wurde wird dem Verwalter die Entlastung für o.g. Wirtschaftsjahr erteilt.";
          var text4 = "Die Entlastung für den Verwaltungsbeirat wird erteilt.";
          var text5 = "Die HV Kappel wird auf weitere 2 Jahre zu den bisherigen Konditionen gewählt. Der Verwaltervertrag endet somit zum 31.12."+(new Date().getFullYear()+2)+".";
          var text6 = "";

          if( count < 6 )
          {
            switch(count) {
              case 0: definedText = text1; break; // 1.
              case 1: definedText = text2; break; // 2.
              case 2: definedText = text3; break; // 3.
              case 3: definedText = text4; break; // 4.
              case 4: definedText = text5; break; // 5.
              case 5: definedText = text6; break; // 6.
              default:;
            }
          }

          var html = "<tr>";
          html += "<td style='width:100%;'><textarea cols='40' rows='3' type='text' name='decision[]' placeholder='Beschluss hier...'>" + definedText + "</textarea></td>";
          html += "<td>" +
                    "<select id='objectPicker"+count+"' class='selectpicker' multiple>" +
                      "<option value='0' selected>Alle</option>";

          //use ajax call to create objects
          //0: {oid: '12345678', hid: '99', title: 'WEG Testland', street: 'Testinger Allee', number: '1b', …}
          glob_creation_objects.forEach(function(object){
            html += "<option value='" + object.oid + "'>" + object.title + /*", " + object.street + " " + object.number + ", " + object.zip + " " + object.city +*/ "</option>";
          })

          html +=   "</select>";
                 "</td>";
          html += "<td style='white-space:nowrap;'>" + 
                    "<div class='form-check'>" +
                      "<input class='form-check-input' type='radio' name='inlineRadioOptions"+count+"' id='inlineRadioOptions1"+count+"' value='1' checked>" +
                      "<label class='form-check-label' for='inlineRadioOptions1"+count+"'>(1) Garage + Whg.</label>" +
                    "</div>" +
                    "<div class='form-check'>" +
                      "<input class='form-check-input' type='radio' name='inlineRadioOptions"+count+"' id='inlineRadioOptions2"+count+"' value='2'>" +
                      "<label class='form-check-label' for='inlineRadioOptions2"+count+"'>(2) nur Whg.</label>" +
                    "</div>" +
                    "<div class='form-check'>" +
                      "<input class='form-check-input' type='radio' name='inlineRadioOptions"+count+"' id='inlineRadioOptions3"+count+"' value='3'>" +
                      "<label class='form-check-label' for='inlineRadioOptions3"+count+"'>(3) nur Garage</label>" +
                    "</div>" + 
                  "</td>";
          html += "<td><button type='button' class='btn btn-danger' onclick='deleteRow(this);'>x</button></td>"
          html += "</tr>";

          var row = document.getElementById("tbody").insertRow();
          row.innerHTML = html;

          $('#objectPicker'+count).selectpicker('');

          count++;
          updateCount();

          window.scrollTo(0,document.body.scrollHeight);
      }

    function deleteRow(button) {
        // first parentElement will be td and second will be tr.
        button.parentElement.parentElement.remove();

        count--;
        updateCount();

        if( count == 0 )
          $('#dropdown_houses').prop('disabled', false);
    }

    function updateCount() {
      var qcount = document.getElementById("q_count");
      qcount.textContent = count + "/30";
    }
  //});
/*************************************** CREATE POLL end /***************************************/


function delayTimer(ms) { return new Promise(res => setTimeout(res, ms)); }