  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">Neue Mitteilung</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Neue Mitteilung</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <form id="newsform">
        <div class="container-fluid">
          <div class="row">
            <div class="col-md-12">
              <div class="card">
                <div class="card-header">
                  <h5 class="card-title">Neue Mitteilung</h5>
                </div>
                <!-- /.card-header -->
                <div class="card-body">
                  <div class="row">
                    <div class="col-md-6">
                      <p class="text-center">


                        <!-- 100% div bg -->
                        <div>
                          <!-- container -->
                          <div class="container">

                            <div class="row">
                              <!-- COLUMN 1 -->
                              <div class="col text-right" style="padding-right: 25px">
                                <!-- NOTIFICATION TOGGLE -->
                                <div style="float:right;width:170px">
                                  <div class="row">
                                    <div class="col">
                                      <b>Notification</b>
                                    </div>
                                    <div class="col">
                                      <label class="switch">
                                        <input type="checkbox" id="notification" name="notification" value="1" checked>
                                        <span class="slider round"></span>
                                      </label>
                                    </div>
                                    <div class="w-100"></div>
                                  </div>
                                </div>
                                <!-- NOTIFICATION TOGGLE -->

                                <!-- CHECKBOXES -->
                                <div style="clear: right;">
                                  <div class="form-check form-check-inline">
                                    <input class="form-check-input" type="checkbox" id="renter" name="renter" value="1" onclick="disableOwnerCouncil(this)">
                                    <label class="form-check-label user-group"><b>Mieter</b></label>
                                  </div>
                                  <br>
                                  <div class="form-check form-check-inline">
                                    <input class="form-check-input" type="checkbox" id="owner" name="owner" value="1" onclick="disableRenterCouncil(this)">
                                    <label class="form-check-label user-group"><b>Eigentümer</b></label>
                                  </div>
                                  <br>
                                  <div class="form-check form-check-inline">
                                    <input class="form-check-input" type="checkbox" id="isCouncil" name="isCouncil" value="1" onclick="disableRenterOwner(this)">
                                    <label class="form-check-label user-group"><b>Beirat</b></label>
                                  </div>
                                  <!-- CHECKBOXES -->

                                  <!-- DROPDOWN -->
                                  <br><br>
                                  <div class="dropdown">
                                    <button type="button" onclick="dropDownHouses()" class="dropbtn btn btn-success">Häuser / Wohnanlagen</button>
                                    <div id="houseDropDown" class="dropdown-content" style="height:320px">
                                      <input type="text" placeholder="Suche.." id="housesInput" name="housesInput" class="dropbtn2" onkeyup="filterHouses()">
                                      <div id="houses" name="houses">
                                        <a href="#">-</a>
                                      </div>
                                    </div>
                                  </div>
                                </div>
                                <br>
                                <div class="row" style="float:right;width:320px">
                                  <div class="col">
                                    <label class="form-check-label"><b>ID</b></label>
                                  </div>
                                  <div class="col">
                                    <input type="text" id="house_id_news" name="house_id_news" readonly size="25">
                                  </div>
                                  <div class="w-100"></div>
                                  <div class="col">
                                    <label class="form-check-label"><b>Name</b></label>
                                  </div>
                                  <div class="col">
                                    <input type="text" id="house_name_news" name="house_name_news" readonly size="25">
                                  </div>
                                </div>
                                <!-- DROPDOWN -->
                              </div>
                              <!-- COLUMN 1 -->


                            </div>
                            <br>
                            
                            <br><br>
                          </div>
                          <!-- container -->
                        </div>
                        <!-- 100% div bg -->



                      </p>
                    </div>
                    <!-- /.col -->
                    <div class="col-md-6">



                      <!-- COLUMN 2 -->
                      <!-- MESSAGE -->
                      <div class="col-sm-6 text-left inputdiv" style="padding-left: 25px">
                        <label class="form-check-label"><b>Titel</b></label>
                        <br>
                        <input type="text" id="title" name="title" placeholder="Titel" autocomplete="on" size="35">
                        <br><br>
                        <label class="form-check-label"><b>Mitteilung</b></label>
                        <br>
                        <textarea rows="6" cols="38" id="text" name="text" placeholder="Text" autocomplete="on"></textarea><br>
                        <small><b><font color="red">Bemerkung:</font></b> <br>Eine Mitteilung an ID "0 | Allgemein" sendet die Mitteilung an ALLE Benutzer.</small><br/>
                      </div>
                      <!-- MESSAGE -->
                      <!-- COLUMN 2 -->



                    </div>
                    <!-- /.col -->
                  </div>
                  <!-- /.row -->




                  <div class="row">
                    <div class="col-12 col-sm-6 col-md-4">
                    </div>
                    <!-- /.col -->
                    <div class="col-12 col-sm-6 col-md-4">
                      <div class="mb-3" style="text-align: center;">
                        <button class="btn btn-primary" id="create_news">Mitteilung erstellen</button>
                        <!-- /.info-box-content -->
                      </div>
                      <!-- /.info-box -->
                    </div>
                    <!-- /.col -->

                    <!-- /.col -->
                    <div class="col-12 col-sm-6 col-md-4">
                    </div>
                    <!-- /.col -->
                  </div>
                  <!-- /.row -->




                </div>
              </div>
              <!-- /.card -->
            </div>
            <!-- /.col -->
          </div>
          <!-- /.row --> 
        </div><!--/. container-fluid -->
      </form>
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <!-- Page specific script -->
<script type="text/javascript" src="js/presenter_news.js?v=1.0"></script>
<script>
  $(function () {
  });
</script>