-- phpMyAdmin SQL Dump
-- version 4.9.0.1
-- https://www.phpmyadmin.net/
--
-- Host: dedi4123.your-server.de
-- Generation Time: Aug 21, 2019 at 10:13 PM
-- Server version: 5.7.27-1
-- PHP Version: 7.1.31

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET AUTOCOMMIT = 0;
START TRANSACTION;
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Database: `steinr_db2`
--

-- --------------------------------------------------------

--
-- Table structure for table `client`
--

CREATE TABLE `client` (
  `pid` bigint(20) NOT NULL DEFAULT '0',
  `hash` varchar(255) NOT NULL,
  `first_name` varchar(50) NOT NULL,
  `last_name` varchar(50) NOT NULL,
  `company` varchar(60) NOT NULL,
  `mobil` varchar(30) NOT NULL,
  `email` varchar(60) NOT NULL,
  `qr_mail_sent` int(11) NOT NULL DEFAULT '0',
  `active` tinyint(4) NOT NULL DEFAULT '1',
  `created_at` timestamp NULL DEFAULT CURRENT_TIMESTAMP
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dumping data for table `client`
--

INSERT INTO `client` (`pid`, `hash`, `first_name`, `last_name`, `company`, `mobil`, `email`, `qr_mail_sent`, `active`, `created_at`) VALUES
(226294810, '0x123', 'Chris GMX', 'A', '', '', 'cfriegel@gmx.de', 2, 1, '2019-08-19 22:07:37'),
(226294851, '0x1234', 'Chris FD', 'B', '', '', 'infofriegel-design.de', 1, 1, '2019-08-19 22:07:07'),
(226294852, '0x12345', 'Tore FD', 'C', '', '', 'tore@friegel-design.de', 1, 1, '2019-08-19 22:07:07'),
(226294853, '0x123456', 'Tore Gmail', 'D', '', '', 'offermann.t@gmail.com', 1, 1, '2019-08-19 22:07:07'),
(226295399, '0x1234567', 'Chris GMail', 'E', '', '', 'chris.friegel@gmail.com', 1, 1, '2019-08-19 22:07:43'),
(226295400, '0x12345678', 'Chris´Company', 'F', 'Company', '', '', 1, 1, '2019-08-19 22:07:43'),
(226295401, '0x123456789', '', '', 'Friegel Design', '', 'info@friegel-design.de', 1, 1, '2019-08-19 22:07:43'),
(226295402, '0x123456789', '', '', 'Friegel Design 2', '', 'info@friegel-design.de', 1, 0, '2019-08-19 22:07:43');

-- --------------------------------------------------------

--
-- Table structure for table `correspondence`
--

CREATE TABLE `correspondence` (
  `cid` int(11) NOT NULL,
  `pid` bigint(20) NOT NULL,
  `hid` int(11) NOT NULL,
  `flat` int(11) NOT NULL,
  `level` int(11) NOT NULL,
  `isCouncil` int(1) NOT NULL DEFAULT '0',
  `created_at` timestamp NULL DEFAULT CURRENT_TIMESTAMP
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dumping data for table `correspondence`
--

INSERT INTO `correspondence` (`cid`, `pid`, `hid`, `flat`, `level`, `isCouncil`, `created_at`) VALUES
(1, 226294810, 34201, 1, 1, 0, '2019-08-19 22:06:54'),
(2, 226294851, 34201, 2, 0, 0, '2019-08-19 22:06:55'),
(3, 226294852, 34201, 2, 0, 0, '2019-08-19 22:06:55'),
(4, 226294853, 34201, 2, 0, 0, '2019-08-19 22:06:55'),
(5, 226295399, 34201, 2, 1, 0, '2019-08-19 22:06:56'),
(6, 226295400, 34201, 2, 1, 0, '2019-08-19 22:06:56'),
(7, 226295401, 34201, 2, 1, 0, '2019-08-19 22:06:56'),
(8, 226295402, 34201, 2, 1, 0, '2019-08-19 22:06:56'),
(64, 226294853, 34274, 2, 0, 0, '2019-08-19 22:06:55'),
(65, 226294810, 34274, 1, 1, 0, '2019-08-19 22:06:54'),
(66, 226294852, 34274, 2, 0, 0, '2019-08-19 22:06:55');

-- --------------------------------------------------------

--
-- Table structure for table `device`
--

CREATE TABLE `device` (
  `hash` varchar(255) NOT NULL,
  `token` varchar(255) NOT NULL,
  `last_used` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dumping data for table `device`
--

INSERT INTO `device` (`hash`, `token`, `last_used`, `created_at`) VALUES
('0x123', 'd44D5IxyNFE:APA91bGhriJB6TeKVcTdJnBF4DvmM6Z-9i3EhG4DcqE0Q4MMLnCR-8QpJpMlQt6fmlDloDdH__HjtQvvj3dpL9cqAao9r3Eeo00hqYRyjaYBQdNOgswifBZaXmRAHIQpS6utDb3HWkQ0', '2019-08-20 20:40:25', '2019-08-20 20:40:25'),
('0x12345', 'eDwvXRml2uY:APA91bGBeoiXjXwldllCjgLcuNnyYYaiWlO_ikS5NNft1getyYro8vXFGAWjaEowvjqGnfnO8p-MlDciHQbiaHuze5_3VTsYG12eQbYp7kngTCeIirZlfki8bKA07jUXxkaGkO5iKd7H', '2019-08-21 20:13:18', '2019-08-21 20:08:08'),
('0x123', 'fAY4bxqMUZM:APA91bHQQDWZv5MigzSBwtfAUAMDxtBWZ0-9wtCm8ZzaBFdUjaWDdJ_Ywao7gXuDGK2qqQPkL4fNPGIahRIWYjtZcyR9Rt-p4YwlXD8lv2NMmtREKSZ606__8M4F5WlbCqwRZK7LNBuj', '2019-08-21 20:09:44', '2019-08-21 20:09:44'),
('0x12345', 'fzRwsv8jP1M:APA91bF1dznPqe_Qldx365JSQARBHQSqADLPPfRDy7MXut5WndE7Er0W4roSmGOL2el1T17zpQEkDxu5eRbnTfs0FYTgEfZaUNUDWDLaXjUkBcNWbAJ_IE613BqSS_NxJvBp77T3VZoN', '2019-08-20 20:33:35', '2019-08-20 20:33:35');

-- --------------------------------------------------------

--
-- Table structure for table `house`
--

CREATE TABLE `house` (
  `hid` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `zip` int(6) UNSIGNED NOT NULL,
  `city` varchar(50) NOT NULL,
  `street` varchar(50) NOT NULL,
  `number` varchar(20) NOT NULL,
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dumping data for table `house`
--

INSERT INTO `house` (`hid`, `name`, `zip`, `city`, `street`, `number`, `created_at`) VALUES
(34201, '89415LauingenKurlandstr. 11-15', 89415, 'Lauingen', 'Kurlandstr. ', '11-15', '2019-08-19 22:06:54'),
(34274, '89415LauingenKurlandstr.75', 89415, 'Lauingen', 'Kurlandstr. ', '75', '2019-08-19 22:06:54');

-- --------------------------------------------------------

--
-- Table structure for table `news`
--

CREATE TABLE `news` (
  `nid` int(11) NOT NULL,
  `title` varchar(255) NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `text` text NOT NULL,
  `level` int(1) NOT NULL DEFAULT '0',
  `isCouncil` int(1) NOT NULL DEFAULT '0',
  `hid` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dumping data for table `news`
--

INSERT INTO `news` (`nid`, `title`, `date`, `text`, `level`, `isCouncil`, `hid`) VALUES
(0, 'sdaf', '2019-08-20 20:40:55', 'sadfs', 1, 0, 34201),
(1, 'test', '2019-08-20 20:24:54', 'test test', 0, 0, 34201),
(2, 'New', '2019-08-21 20:10:52', 'New', 1, 0, 34274);

--
-- Indexes for dumped tables
--

--
-- Indexes for table `client`
--
ALTER TABLE `client`
  ADD PRIMARY KEY (`pid`);

--
-- Indexes for table `correspondence`
--
ALTER TABLE `correspondence`
  ADD PRIMARY KEY (`cid`);

--
-- Indexes for table `device`
--
ALTER TABLE `device`
  ADD PRIMARY KEY (`token`),
  ADD UNIQUE KEY `token` (`token`);

--
-- Indexes for table `house`
--
ALTER TABLE `house`
  ADD PRIMARY KEY (`hid`);

--
-- Indexes for table `news`
--
ALTER TABLE `news`
  ADD PRIMARY KEY (`nid`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `correspondence`
--
ALTER TABLE `correspondence`
  MODIFY `cid` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=67;

--
-- AUTO_INCREMENT for table `house`
--
ALTER TABLE `house`
  MODIFY `hid` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=34275;

--
-- AUTO_INCREMENT for table `news`
--
ALTER TABLE `news`
  MODIFY `nid` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;
COMMIT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
