<?php

class ClientClass
{
  public $client_update_type = -1;
  public $houseId = "";
  public $flat = "";
  public $level = -1; //e.g. wohnungsnummer 1
  public $isCouncil = 0; // 0 = Mieter, 1 = Eigentümer
  public $flatWeight = 0; //-1 should be default, but actullay 0 is better
  public $garageWeight = 0;
  public $id = "";
  public $firstName = ""; //e.g. personennummer 1
  public $firstName2 = "";
  public $company = "";
  public $surname = "";
  public $surname2 = "";
  public $mobil = "";
  public $email = "";
  public $email2 = "";
  public $objectId = "";
  public $hasFlatChanged = false;

  // flat, level, isCouncil should not be in use,
  // since we always delete and re-create on change (cuz of multiple matching entries)
  public $hasLevelChanged = false;
  public $hasIsCouncilChanged = false;
  public $hasFlatWeightChanged = false;
  public $hasGarageWeightChanged = false;
  public $hasFirstNameChanged = false;
  public $hasFirstName2Changed = false;
  public $hasSurnameChanged = false;
  public $hasSurname2Changed = false;
  public $hasIsCompanyChanged = false;
  public $hasMobilChanged = false;
  public $hasEmailChanged = false;
  public $hasEmail2Changed = false;
  public $newEntry = false;
  public $isClientTable = false;

  public function setUpdateType(int $type): void
  {
    $this->client_update_type = $type;
  }

}