<?php

abstract class FlatType
{
  const UNKNOWN = -1;
  const FLAT = 0;
  const GARAGE = 1;
  const OFFICE = 2;
  const BUSINESS = 3;

  public static function toString($type): string
  {
    switch ($type) {
      case self::FLAT:
        return "flat";
      case self::GARAGE:
        return "garage";
      case self::OFFICE:
        return "office";
      case self::BUSINESS:
        return "business";
      default:
        return "unknown";
    }
  }
}