<?php 
  // Headers
  header('Access-Control-Allow-Origin: *');
  header('Content-Type: application/json');
  header('Access-Control-Allow-Methods: DELETE');
  header('Access-Control-Allow-Headers: Access-Control-Allow-Headers,Content-Type,Access-Control-Allow-Methods, Authorization, X-Requested-With');

  include_once '../../config/database.php';
  include_once '../../models/news.php';

  // Instantiate DB & connect
  $database = new Database();
  $db = $database->connect();

  // Instantiate blog news object
  $news = new News($db);

  // Get raw posted data
  $news->nid = $_POST["nid"];

  // Delete news
  if($news->delete_news()) {
    error_log( "INFO: News deleted...", 0);
    echo json_encode(
      array('message' => 'News Deleted')
    );
  } else {
    error_log( "WARNING: News NOT deleted...", 0);
    echo json_encode(
      array('message' => 'News Not Deleted')
    );
  }