<?php 
  //include_once '../../config/header_default_server.php';
  include_once '../../config/database.php';

  include_once '../../models/poll.php';

  // Instantiate DB & connect
  $database = new Database();
  $db = $database->connect();

  // Instantiate poll object
  $poll = new Poll($db);


  /**************************************************/

  // Get raw posted data and check if data exists
  $data = json_decode(file_get_contents("php://input"));
  if( !isset( $data) ) {
    error_log( "WARNING: PollActive body data were not found... ", 0);
    header("HTTP/1.1 404 Not Found");
    exit();
  }

  /**************************************************/


  if( isset($data->phash) )
    $poll->phash = urldecode( $data->phash );
  if( isset($data->active) )
    $poll->active = urldecode( $data->active );


  if( $poll->is_any_poll_active() )
    echo 0;
  else {
    if( $poll->toggle_active() == false )
      echo 2;
    else
      echo 1;
  }
