<?php 
  // Headers
  header('Access-Control-Allow-Origin: *');
  header('Content-Type: application/json');
  header('Access-Control-Allow-Methods: PUT');
  header('Access-Control-Allow-Headers: Access-Control-Allow-Headers,Content-Type,Access-Control-Allow-Methods, Authorization, X-Requested-With');

  include_once '../../config/database.php';
  include_once '../../models/client.php';

  // Instantiate DB & connect
  $database = new Database();
  $db = $database->connect();

  // Instantiate blog client object
  $client = new Client($db);

  // Get raw posted data
  $tag = $_POST["tag"];

  //create
  if( $tag == 1 )
  {
    $client->pid = $_POST["id"];
    $client->first_name = $_POST["first_name"];
    $client->last_name = $_POST["last_name"];
    $client->first_name2 = $_POST["first_name2"];
    $client->last_name2 = $_POST["last_name2"];
    $client->company = $_POST["company"];
    $client->flat = $_POST["flat"];
    $client->email = $_POST["email"];
    $client->email2 = $_POST["email2"];
    $client->mobil = $_POST["mobil"];
    $client->house_id = $_POST["house_id"];
    $client->level = $_POST["level"];
    $client->isCouncil = $_POST["isCouncil"];
    $client->flatWeight = $_POST["flatWeight"];
    $client->garageWeight = $_POST["garageWeight"];
    $client->object_id = $_POST["object_id"];

    if( !$client->create_client() ) 
      report_error();

    //print "Create: " . $client->pid . " - " . $client->first_name . " - " . $client->last_name . " - " . $client->company . " - " . $client->flat . " - " . $client->email . " - " . $client->house_id . " - " . $client->level . " - " . $client->isCouncil . " - " . $client->flatWeight;
  }
  //delete
  elseif( $tag == 2 )
  {
    $client->pid = $_POST["id"];
    $client->house_id = $_POST["house_id"];
    $client->flat = $_POST["flat"];
    $client->isCouncil = $_POST["isCouncil"];
    $client->flatWeight = $_POST["flatWeight"];
    $client->garageWeight = $_POST["garageWeight"];

    if( !$client->delete_correspondences() )
      report_error();

    //print "Delete: " . $client->pid . " - " . $client->house_id;
  }
  //update
  elseif( $tag == 3 )
  {
    $client->pid = $_POST["id"];
    $client->first_name = $_POST["first_name"];
    $client->last_name = $_POST["last_name"];
    $client->first_name2 = $_POST["first_name2"];
    $client->last_name2 = $_POST["last_name2"];
    $client->company = $_POST["company"];
    $client->flat = $_POST["flat"];
    $client->email = $_POST["email"];
    $client->email2 = $_POST["email2"];
    $client->mobil = $_POST["mobil"];
    $client->house_id = $_POST["house_id"];
    $client->object_id = $_POST["object_id"];

    if( !$client->update_client() )
      report_error();
    
    /*
    print "Update: " . $client->pid . " - " . $client->first_name . " - " . $client->last_name . " - " . $client->company . " - " . $client->flat . " - " . $client->email . " - " . $client->house_id . " - " . $client->level . " - " . $client->isCouncil . " - " . $client->flatWeight;
    */
  }
  //update flat_weight
  elseif( $tag == 4 )
  {
    $client->pid = $_POST["id"];
    $client->house_id = $_POST["house_id"];
    $client->flat = $_POST["flat"];
    $client->level = $_POST["level"];
    $client->isCouncil = $_POST["isCouncil"];
    $client->flatWeight = $_POST["flatWeight"];
    $client->garageWeight = $_POST["garageWeight"];

    if( !$client->update_flatweight() )
      report_error();
    
    
    /*
    print "Update flat_weight: " . $client->pid . " - " . $client->house_id . " - " . $client->flat . " - " . $client->level . " - " . $client->isCouncil . 
      " - " . $client->flatWeight;
    */
  }

  function report_error()
  {
    //die( header("HTTP/1.0 404 Not Found") );
    header("HTTP/1.0 500 Internal Server Error");
    print 'Error';
    exit();
  }