<?php 
  // Headers
  header('Access-Control-Allow-Origin: *');
  header('Content-Type: application/json');
  header('Access-Control-Allow-Methods: POST');
  header('Access-Control-Allow-Headers: Access-Control-Allow-Headers,Content-Type,Access-Control-Allow-Methods, Authorization, X-Requested-With');

  include_once '../../config/database.php';
  include_once '../../models/news.php';

  // Instantiate DB & connect
  $database = new Database();
  $db = $database->connect();

  // Instantiate blog news object
  $news = new News($db);

  // Get raw posted data
  $data = json_decode(file_get_contents("php://input"));

  $id = 34201;
  $endid = 34273;

  for( ; $id<=$endid; $id++ ){

    //assign data to news class
    $news->title = "Herzlich willkommen!";
    $news->text = "Wir freuen uns, dass Sie unsere App der Kappel Hausverwaltung benutzen und wünschen Ihnen viel Vergnügen!";
    $news->house_id = $id;

    //MIETER
    $news->level = 0;

    // Create news
    if( $news->create_news() ) {
        echo json_encode(
          array('message' => 'News Created')
        );
      }
    else {
      echo json_encode(
        array('message' => 'News NOT created')
      );
    }

    //EIGENTÜMER
    $news->level = 1;

    // Create news
    if( $news->create_news() ) {
        echo json_encode(
          array('message' => 'News Created')
        );
      }
    else {
      echo json_encode(
        array('message' => 'News NOT created')
      );
    }

  }