<?php 
  $ignoreDeviceId = true;

  include_once '../../config/header_default.php';
  include_once '../../config/database.php';

  include_once '../../models/ologging.php';

  // Instantiate DB & connect
  $database = new Database();
  $db = $database->connect();

  // Instantiate blog news object
  $olog = new OLog($db);


  /**************************************************/

  // Get raw posted data and check if data exists
  $data = json_decode(file_get_contents("php://input"));
  if( !isset( $data) ) {
    error_log( "WARNING: OLogging body data were not found... deviceId: " . $hDeviceId, 0);
    header("HTTP/1.1 404 Not Found");
    exit();
  }

  /**************************************************/
  

  //assign data to logging class
  if( isset($data->tag) )
    $olog->tag = urldecode( $data->tag );

  if( isset($data->message) )
    $olog->message = urldecode( $data->message );

  $olog->deviceId = urldecode( $hDeviceId );

  // Create olog
  if( $olog->tag != "" && $olog->create_log() ) {
    header("HTTP/1.1 200 OK");
    exit();
  } 
  else {
    error_log( "WARNING: OLogging issue... deviceId" . $hDeviceId, 0);
    header("HTTP/1.1 404 Not Found");
    exit();
  }