$(document).ready(function() {
//jQuery(document).ready(function($) {

  fetch_data();  
});


function fetch_data()  
{
  var req = new XMLHttpRequest();
  req.open("GET", '../api/v2/get_app_logs.php',true);
  req.send();

  req.onload=function(){
    var json=JSON.parse( req.responseText );
    qrArray = json;

    var html = "";
    html = "<div >"+  //class='table-responsive'
             "<table id='table_id' class='table table-bordered table-hover dataTable dtr-inline' style='table-layout: fixed; width: 100%;'>"+  //table table-bordered 
                "<thead><tr>"+
                     "<th>lid</th>"+  
                     "<th>tag</th>"+ 
                     "<th>message</th>"+  
                     "<th>deviceId</th>"+  
                     "<th>timestamp</th>"+  
                "</tr></thead>"; 

    html += "<tbody>";

    if( Array.isArray(json) ) {
      json.forEach(function(val) {
          var keys = Object.keys(val);

          html +=    "<td class='lid'>" + val.lid + "</td>";
          html +=    "<td class='tag'>" + val.tag + "</td>";
          html +=    "<td class='message'>" + val.message + "</td>";
          html +=    "<td class='deviceId'>" + val.deviceId + "</td>";
          html +=    "<td class='timestamp'>" + val.timestamp + "</td>";
          
          html +=  "</tr>";
      });
    }
    html += "</tbody></table>";

    $('#live_data').html(html); 

    $('#table_id').DataTable( {
        "paging": true,
        "lengthChange": false,
        "searching": true,
        "ordering": true,
        "info": true,
        "autoWidth": true,
        "responsive": false,
        "lengthMenu": [[5, 10, 25, 50, -1], [5, 10, 25, 50, "All"]],
        "pageLength": 25,
        "columnDefs": [ 
        {
            targets: [ 0 ],
            width: '3%', 
        }, {
            targets: [ 1 ],
            width: '10%', 
        }, {
            targets: [ 2 ],
            width: '50%', 
        }, {
            targets: [ 3 ],
            width: '8%', 
        }, {
            targets: [ 4 ],
            width: '5%', 
        } ],
        "order": [[ 0, "desc" ]]
    } );
  }
}