$(document).ready(function() {

  fetch_qr_data();  

});

var qrCounter = 0;
var qrLength = 0;
var qrArray = null;

function sendQRMailToALL() {
  if(confirm("Möchtest Du die QR-Codes wirklich senden?"))  
  {
    qrLength = qrArray.length;
    appendItem( qrLength );
    //qrArray = json; //this will be done after json is created
    if(confirm("Nur auf Nummer Sicher zu gehen: Möchtest Du die QR-Codes wirklich senden?"))
      sendQRMailToALLOneByOne();
  }
}

function sendQRMailToALLOneByOne() {
  //console.log( qrArray );

  if( qrCounter >= qrLength ){
    //console.log( "done" );
    appendItem( "done" );
    return; 
  }

  if( qrArray[ qrCounter ].qr_mail_sent > 0 || qrArray[ qrCounter ].active == 0 ) {
    appendItem( "<font color=red>ALREADY SENT OR INACTIVE:</font> " + qrCounter + " - " + qrArray[ qrCounter ].pid + " - " + qrArray[ qrCounter ].last_name + " - " + qrArray[ qrCounter ].first_name + " - " + qrArray[ qrCounter ].company + " - " + qrArray[ qrCounter ].hash + " - " + qrArray[ qrCounter ].email + " - " + qrArray[ qrCounter ].qr_mail_sent + " - " + qrArray[ qrCounter ].active );
    qrCounter += 1;
    sendQRMailToALLOneByOne();
  }
  else {
    //testing purposes
      //console.log( qrCounter, qrArray[ qrCounter ].pid, qrArray[ qrCounter ].last_name, qrArray[ qrCounter ].first_name, qrArray[ qrCounter ].company, qrArray[ qrCounter ].hash, qrArray[ qrCounter ].email, qrArray[ qrCounter ].qr_mail_sent );
      //appendItem( "<font color=green>SENT:</font> " + qrCounter + " - " + qrArray[ qrCounter ].pid + " - " + qrArray[ qrCounter ].last_name + " - " + qrArray[ qrCounter ].first_name + " - " + qrArray[ qrCounter ].company + " - " + qrArray[ qrCounter ].hash + " - " + qrArray[ qrCounter ].email + " - " + qrArray[ qrCounter ].qr_mail_sent + " - " + qrArray[ qrCounter ].active );
      //qrCounter += 1;
      //sendQRMailToALLOneByOne();
      //dont fort get to CTRL+F5 before using the test code!!

    //very similar to sendQRMail()
    $.ajax({
            type: "POST",
            url:"../api/server/send_qr.php",  
            data:{ pid: qrArray[ qrCounter ].pid, last_name: qrArray[ qrCounter ].last_name, first_name: qrArray[ qrCounter ].first_name, company: qrArray[ qrCounter ].company, hash: qrArray[ qrCounter ].hash, mail: qrArray[ qrCounter ].email },
            dataType: "text", //text/html
            success:function(data){
              console.log( data );
              setTimeout(function() {
                appendItem( "<font color=green>SENT:</font> " + qrCounter + " - " + qrArray[ qrCounter ].pid + " - " + qrArray[ qrCounter ].last_name + " - " + qrArray[ qrCounter ].first_name + " - " + qrArray[ qrCounter ].company + " - " + qrArray[ qrCounter ].hash + " - " + qrArray[ qrCounter ].email + " - " + qrArray[ qrCounter ].qr_mail_sent + " - " + qrArray[ qrCounter ].active );
                qrCounter += 1;
                sendQRMailToALLOneByOne();
              }, 1000);
            },
            error: function(err){
                //alert("Fehler beim Senden der Mail: " + err.Message);
                appendItem( "<font color=red>ERROR:</font> " + qrCounter + " - " + qrArray[ qrCounter ].pid + " - " + qrArray[ qrCounter ].last_name + " - " + qrArray[ qrCounter ].first_name + " - " + qrArray[ qrCounter ].company + " - " + qrArray[ qrCounter ].hash + " - " + qrArray[ qrCounter ].email + " - " + qrArray[ qrCounter ].qr_mail_sent + " - " + qrArray[ qrCounter ].active + " | " + err.Message );
                qrCounter += 1;
                sendQRMailToALLOneByOne();
            }
        });
    
    //use this only if ajax is commented out
    /*setTimeout(function(){
      appendItem( "<font color=green>SENT:</font> " + qrCounter + " - " + qrArray[ qrCounter ].pid + " - " + qrArray[ qrCounter ].last_name + " - " + qrArray[ qrCounter ].first_name + " - " + qrArray[ qrCounter ].company + " - " + qrArray[ qrCounter ].hash + " - " + qrArray[ qrCounter ].email + " - " + qrArray[ qrCounter ].qr_mail_sent + " - " + qrArray[ qrCounter ].active );
      qrCounter += 1;
      sendQRMailToALLOneByOne();
    }, 1000);*/

  }
}

function appendItem( $item ) {
  var div = document.getElementById('SentList');
  div.innerHTML += "<li>" + $item + "</li>";
}

function fetch_qr_data() {
  var req = new XMLHttpRequest();
  req.open("GET", '../api/server/get_clientz.php?code=1337',true);
  req.send();

  req.onload=function(){
    var json=JSON.parse( req.responseText );
    qrArray = json;

    var html = "";
    html = "<div >"+  //class='table-responsive' 
             "<table id='table_qr' class='table table-bordered table-hover dataTable dtr-inline' style='table-layout: fixed; width: 100%;'>"+  //table table-bordered 
                "<thead><tr>"+
                     "<th>ID</th>"+  
                     "<th>Name</th>"+  
                     "<th style='word-wrap: break-word; width: 100px'>Hash</th>"+  
                     "<th>Aktiv</th>"+  
                     "<th>QR-Mail</th>"+  
                     "<th>QR-Mail Sent</th>"+  
                "</tr></thead>"; 

    html += "<tbody>";
    json.forEach(function(val) {
        var keys = Object.keys(val);

        html += "<tr>" +
                     "<td>" + val.pid + "</td>" +
                     "<td class='last_name'>" + val.last_name + " " + val.first_name + " " + val.company + "</td>" +
                     "<td class='hash' style='word-wrap: break-word; width: 100px'>" + val.hash + "</td>" +
                     "<td class='hash'>" + val.active + "</td>" +
                     "<td class='hash'>" + val.email + "</td>";

        html +=    "<td class='qr_mail_sent'>" + val.qr_mail_sent + "</td>"; 
        	
        html +=  "</tr>";
    });
    html += "</tbody></table>";

    html += "<br><br><a style='cursor:pointer;color:red;' onclick='sendQRMailToALL()'>QR Code an ALLE senden<br>die bisher noch keine erhalten haben - siehe \"QR-Mail sent\"</a>";

    //append in message class
    //document.getElementsByClassName('message')[0].innerHTML=html;
    $('#live_qr_data').html(html); 

    $('#table_qr').DataTable( {
        //responsive: true,
        //"autoWidth": false,
        /*"columns": [
          { "sType": 'numeric' },
          { "sType": 'numeric' },
          null,
          null,
          null,
          null,
          null,
          null
        ],*/
        "paging": true,
        "lengthChange": false,
        "searching": true,
        "ordering": true,
        "info": true,
        "autoWidth": true,
        "responsive": true,
        "lengthMenu": [[5, 10, 25, 50, -1], [5, 10, 25, 50, "All"]],
        "columnDefs": [{ 
          width: '40%', 
          targets: 2 
        }],
        "order": [[ 1, "asc" ]]
    } );
  }
}